'use strict'
const meta = require('meta-ngin')
const winston = require('winston')
const util = require('./util')
const config = require('./config')

module.exports = function (req, res) {
  if (!config.configured()) throw new Error('The identity-code-api-controllers must be configured prior to a request. Please refer to the middleware section of this module.')
  winston.info('Retrieving a single resource')
  util.getObjects()
    .then(data => {
      let response = util.formatRes(util.getObject(data, req.params[config.retrieve.resourceNameSingular()], req.params[config.retrieve.sortNameSingular()])[0])
      res.status(200).send(response)
    })
    .catch(err => {
      console.error(err)
      if (err.message === 'Resource not found') res.status(404).send({metadata: meta(404, err.message)})
      else res.status(500).send({metadata: meta(500, err.message)})
    })
}
